<style>
  .jstree-default > .jstree-striped {
    width: 100%;
  }
  .jstree-node>a {
    width: calc(100% - (80px + 1px + 4px));
    text-overflow: ellipsis;
    overflow: hidden;
  }
</style>

<div class="modal-header">
  <h5 class="modal-title" id="exampleModalLabel"><%= @modal_title.nil? ? Admin::PerimeterRca.model_name.human : @modal_title %></h5>
  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
    <span aria-hidden="true">&times;</span>
  </button>
</div>

<div class="modal-body">
  <div id="tree_content_ajaxtree" style='padding-top: 5px;'>
    <button class="btn" id="expand_perimeter_tree" type='input'><%= t('.expend')%></button>
    <button class="btn" id="collapse_perimeter_tree"><%= t('.collapse') %></button>

    <button class="btn" id="select_perimeter_tree" type='input'><%= t('.select_all')%></button>
    <button class="btn" id="unselect_perimeter_tree"><%= t('.unselect_all') %></button>

    <div id='tree_zone'>
      <div id="js_tree_perimeter_assign"></div>
    </div>
    <br>
  </div>
</div>

<div class="modal-footer">
  <%= hidden_field_tag 'rca_id', @rca.id %>
  <button class="btn btn-outline-warning" id="valid_perimeters_checked"><%= t('.valid') %></button>
</div>

<script>
  $(function(){
    // Tree Contents Tree
    mytree = $('#js_tree_perimeter_assign')
    .bind("loaded.jstree", function (e, data) {
        data.instance.open_all();
    })
    .bind("refresh.jstree", function (e, data) {
        data.instance.open_all();
    })
    .jstree({
        "plugins" : [ "themes", "types", "wholerow", "sort", "checkbox"], //, "stackedicon" ],  //
        "themes" : {
            "theme" : "default",
            "icons" : false
        },
        "core": {
            "animation" : 0 ,
            "check_callback" :  function (operation, node_obj, node_parent, node_position, more) {
                                  // Pour empêcher le déplacement de type reorder
                                  if (more && more.dnd && more.pos !== "i") { return false; }
                                  // D&D
                                  if (operation === "move_node") {
                                    return true
                                  }
                                  return true;
                                },
            "themes" : { "stripes" : true },
            "multiple" : true,
            "data" : { "url" : '<%= Rails.application.routes.url_helpers.admin_perimeters_js_tree_data_path(locale: I18n.locale, show_buttons: false, attrib_class: 'Rca', attrib_id: @rca.id) %>',
                       "data" : function(node) {
                                return { 'id' : node.id };
                            }
                     }
        },
        //"dnd" : { "copy": false, "use_html5" : true, "insid e_pos" : "last" },
        "types" : {
                    "#" : { "icon": "fas fa-universal-access icon_tree_tag" },
                    'perimeter': { "icon": "fas fa-map-marker icon_tree_tag" }
                  },
        // Tri les élems par ID => même ordre que dans la BDD
        "sort" : function (a, b) { return (parseInt(a) < parseInt(b)) ? -1 : 1; },
        // ,
        'checkbox': {  cascade: "", three_state: false
                      // three_state : false, // to avoid that fact that checking a node also check others
                      // whole_node : false,  // to avoid checking the box just clicking the node
                      // tie_selection : false // for checking without selecting and selecting without checking
                    } // , 'three_state': false }
    })
    .on('select_node.jstree', function (e, data) {
        if (data.event) {
            data.instance.select_node(data.node.children_d);
        }
    })
    .on('deselect_node.jstree', function (e, data) {
        if (data.event) {
            data.instance.deselect_node(data.node.children_d);
        }
    })

    $('#expand_perimeter_tree').on("click", function() {
      $("#js_tree_perimeter_assign").jstree("open_all");
    });
    $('#collapse_perimeter_tree').on("click", function() {
      $("#js_tree_perimeter_assign").jstree("close_all");
    });
    $('#select_perimeter_tree').on("click", function() {
      $("#js_tree_perimeter_assign").jstree("select_all");
    });
    $('#unselect_perimeter_tree').on("click", function() {
      $("#js_tree_perimeter_assign").jstree("deselect_all");
    });

    $('#valid_perimeters_checked').on('click', function() {
      let results = $('#js_tree_perimeter_assign').jstree("get_checked", false);
      console.log("CHECKED NODES = ");
      console.log(results);

      let rca_id = $('#rca_id').val();
      console.log('RCA ID = ');
      console.log(rca_id);

      let url = "<%= rcas_assign_perimeters_valid_url %>";

      let datas = {};
      datas = {'id': rca_id, 'perimeter_ids': results}
      $.ajax({
        url: url,
        type: 'PATCH',
        data: datas,
        dataType: 'script',
        beforeSend: function(xhr) {xhr.setRequestHeader('X-CSRF-Token', $('meta[name="csrf-token"]').attr('content'));},
        success: function(data) {
          console.log('attribution done.');
        }
      });
    });

    $('li[data-checkstate="checked"]').each(function() {
      $("#js_tree_perimeter_assign").jstree('check_node', $(this));
    });
  });
</script>
